# Copyright (c) 2014 Dave Love, Liverpool University
# Licence: MIT, per Fedora policy

%global packname  kazaam
%global rlibdir	 %{_libdir}/R/library
%global cranver %(echo %version | awk -F'[.]' '{print $1"."$2"-"$3}')
# Use github source if more recent than CRAN
%global github 1
%if 0
%{?el7:%global three 3}
%endif


Name:		  R-%{packname}
Version:	  0.2.0
Release:	  1%{?dist}
Summary:	  R tools for tall distributed matrices
License:	  BSD
URL:		  http://r-pbd.org/
%if 0%{?github}
Source0:          https://github.com/RBigData/%packname/archive/v%cranver/%{packname}-%version.tar.gz
%else
Source0:	  http://cran.r-project.org/src/contrib/%{packname}_%(echo %version | awk -F'\\.' '$4=="" {print $1"."$2"-"$3} $4!="" {print $1"."$2"-"$3"."$4}').tar.gz
%endif
Requires:	  R-pbdMPI%{?_isa} >= 0.3.9
BuildRequires:	  R-devel tex(latex) R-pbdMPI >= 0.3.9 openmpi-devel
BuildRequires:	  tex(lastpage.sty)


%description
Many data science problems reduce to operations on very tall, skinny
matrices.  However, sometimes these matrices can be so tall that they
are difficult to work with, or do not even fit into main memory.  One
strategy to deal with such objects is to distribute their rows across
several processors.  To this end, kazaam offers an 'S4' class for
tall, skinny, distributed matrices, called the 'shaq' and provides
many useful numerical methods and statistics operations for operating
on these distributed objects.

%prep
%setup -q -c -n %{packname}

%build
%if 0%{?github}
%if 0%{?three}
%_openmpi3_load
%else
%_openmpi_load
%endif
R CMD build %{packname}*
tar fx %{packname}*.tar.gz
%endif

%install
mkdir -p %{buildroot}%{rlibdir}
%if 0%{?three}
%_openmpi3_load
%lse
%_openmpi_load
%endif
OMPI_MCA_orte_allocation_required=0 OMPI_MCA_orte_rsh_agent=/bin/false \
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css

%check
%_openmpi_load
OMPI_MCA_orte_allocation_required=0 OMPI_MCA_orte_rsh_agent=/bin/false \
%{_bindir}/R CMD check %{packname}


%files
# Not actually a licence
%exclude %{rlibdir}/%{packname}/LICENSE
%dir %{rlibdir}/%{packname}
%doc %{rlibdir}/%{packname}/doc
%doc %{rlibdir}/%{packname}/html
%{rlibdir}/%{packname}/CITATION
%{rlibdir}/%{packname}/DESCRIPTION
%{rlibdir}/%{packname}/help
%{rlibdir}/%{packname}/INDEX
%{rlibdir}/%{packname}/NAMESPACE
%{rlibdir}/%{packname}/Meta
%{rlibdir}/%{packname}/R
%{rlibdir}/%{packname}/libs
%{rlibdir}/%{packname}/batchtests


%changelog
* Tue Jul  2 2019 Dave Love <loveshack@fedoraproject.org> - 0.2.0-1
- New version from github (for CORAL2 benchamrks)
- BR lastpage.sty

* Tue Jul  2 2019 Dave Love <loveshack@fedoraproject.org> - 0.1.0-4
- Rebuild for R 3.6

* Tue Apr 23 2019 Dave Love <loveshack@fedoraproject.org> - 0.1.0-3
- Rebuild for current R

* Wed May  9 2018 Dave Love <loveshack@fedoraproject.org> - 0.1.0-2
- Fix some erroneous %%doc

* Tue May  8 2018 Dave Love <loveshack@fedoraproject.org> - 0.1.0-1
- Initial package
